import { Asset, AssetSymbol, Chain, ChainKey, MoonChain, WithdrawConfig } from '@moonbeam-network/xcm-config';
import { Signer as EthersSigner } from 'ethers';
import { XTokensContract } from '../contracts';
import { PolkadotService } from '../polkadot';
import { ExtrinsicEvent, Hash, SdkOptions, WithdrawTransferData } from './sdk.interfaces';
export declare function createTransactionEventHandler(ethersSigner: EthersSigner, txHash: Hash, cb: (event: ExtrinsicEvent) => void, skipSentEvent?: boolean): Promise<void>;
export interface GetWithdrawDataParams<Symbols extends AssetSymbol, ChainKeys extends ChainKey> {
    asset: Asset<Symbols>;
    config: WithdrawConfig<Symbols>;
    contract: XTokensContract;
    destinationAccount: string;
    destinationPolkadot: PolkadotService<Symbols, ChainKeys>;
    moonChain: MoonChain;
    nativeAsset: Asset<Symbols>;
    options: SdkOptions;
    origin: MoonChain | Chain<ChainKeys>;
    polkadot: PolkadotService<Symbols, ChainKeys>;
}
export declare function getWithdrawData<Symbols extends AssetSymbol, ChainKeys extends ChainKey>({ asset, config, contract, destinationAccount, destinationPolkadot, moonChain, nativeAsset, options, origin, polkadot, }: GetWithdrawDataParams<Symbols, ChainKeys>): Promise<WithdrawTransferData<Symbols>>;
